/* This is a tool for bruteforcing domain names , 
 * which dont have reverse lookup.
 * Some examples
 * bd -i wordlist.txt superonline.com # Use the words from input file
 * bd -s 2 -e 4 superonline.com  # Generate words min 2 chars max 4 chars
 * bd -p superonline.com    # Prefined words
 * 
 * "BruteDomain"
 * c0ded by Serkan Akpolat serkan@core.gen.tr
 * Homepage http://www.core.gen.tr/~serkan
 * 
 * Greetz to all core security friends 
 * 
 * Compile it like:
 * gcc brutedomain.c -Wall -ansi -o bd
 */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <netdb.h>

#define VERSION "v0.2"
#define AUTHOR "Serkan Akpolat"
#define BUFSIZE 32
int *f = NULL;
char domain[256];

void frominputfile(char *filename, char *hostnm)
{
	char buf[BUFSIZE + 1];
	FILE *fp;
	struct hostent *ht;

	if ((fp = fopen(filename, "r")) == NULL) {
		fprintf(stderr, "Error opening File.\n");
		exit(1);
	}

	while (!feof(fp)) {
		fgets(buf, BUFSIZE, fp);
		if (buf != NULL && buf[strlen(buf) - 1] == '\n')
			buf[strlen(buf) - 1] = '\0';
		strcat(buf, ".");
		strcat(buf, hostnm);
		ht = gethostbyname(buf);
		if (ht == NULL) {
			continue;
		} else {
			printf("%s-> %s\n", buf,inet_ntoa(*((struct in_addr *) ht->h_addr)));
			memset(buf, '\0', BUFSIZE + 1);
		}
	}

	fclose(fp);
	puts("Have a nice day!");
	exit(0);
}





void check(int *d, char *_string)
{
	int j = 0;
	char *leet = NULL;
	leet = &_string[strlen(_string) - 1];
	j = strlen(_string);
	if (j == 1 && *leet == 'z') {
		*d = *d + 1;
		return;
	}
	if (*leet == 'z') {
		*leet = 'a';
		while (1) {
			leet = leet - 1;
			if (*leet == 'z') {
				if (leet == &_string[0] && *leet == 'z') {
					*d = *d + 1;
					break;
				}
				*leet = 'a';
				continue;
			}

			else {
				break;
			}
		}
	}
	if (*d == 0)
		*leet = *leet + 1;
}



void usage_info()
{
	fprintf(stderr,
		"BruteDomain c0ded by %s\n"
		"Bruteforces Domain names which don't have reverse lookup \n\n"
		"Look only for predefined words:\n"
		"Example : #bd -p superonline.com\n\n"
		"Blind bruteforce words:\n"
		"Example : #bd -s 2 -e 4 superonline.com \n\n"
		"Use the words from input file:\n"
		"Example : #bd -i wordlist.txt superonline.com\n", AUTHOR);

	exit(0);
}




void predefined(char *argg)
{
	int i = 0;
	char fix_list[22][22] =
	    { "mail", "pop", "fw1", "fw2", "fw", "admin", "setup",
		"smtp", "pop3", "pop", "lab", "check", "as", "www",
		"ftp", "router", "dns", "ns1", "ns2", "ns", "imap"
	};
	struct hostent *ht;
	for (; i < 21; i++) {
		strcpy(domain, fix_list[i]);
		strcat(domain, ".");
		strcat(domain, argg);
		ht = gethostbyname(domain);
		if (ht == NULL) {
			continue;
		} else {
			printf("%s-> %s\n", domain,
					inet_ntoa(*((struct in_addr *) ht->h_addr)));
			memset(domain, '\0', 256);
		}
	}
	puts("_EOF_");
	exit(0);
}




int main(int argc, char **argv)
{
	char *c = malloc(100), *s = malloc(30),
	*e = malloc(30), *my_string = malloc(63);
	int choice = 0, i = 0, start, end;
	struct hostent *hp;
	while (i < argc - 1) {
		i++;
		if (!strcmp(argv[i], "-help"))
			usage_info();
		else if (!strcmp(argv[i], "-p")) {
			i++;
			if (argc < 3)
				usage_info();
			strncpy(c, argv[i], 100);
			predefined(c);
		} else if (!strcmp(argv[i], "-i")) {
			i++;
			if (argc < 4)
				usage_info();
			strncpy(my_string, argv[i], 100);
			i++;
			strncpy(c, argv[i], 100);
			frominputfile(my_string, c);
		} else if (!strcmp(argv[i], "-s")) {
			i++;
			if (argc < 3)
				usage_info();
			strncpy(s, argv[i], 10);
		} else if (!strcmp(argv[i], "-e")) {
			i++;
			if (argc < 6)
				usage_info();
			strncpy(e, argv[i], 10);
			i++;
			strncpy(c, argv[i], 100);
		} else
			usage_info();
	}

	f = malloc(sizeof(int));
	sscanf(s, "%d", &start);
	sscanf(e, "%d", &end);
	if (start <= 0 || end < 0)
		usage_info();
	if (start >= end)
		usage_info();

	memset(my_string, 'a', start);

	for (choice = start; choice <= end; choice++) {
		*f = 0;
		if (my_string[0] == 'z') {
			memset(my_string, '\0', choice);
			memset(my_string, 'a', choice);
		}

		while (*f == 0) {
			strcpy(domain, my_string);
			strcat(domain, ".");
			strcat(domain, c);
			hp = gethostbyname(domain);
			check(f, my_string);
			if (hp == NULL) {
				continue;
			} else {
				printf("%s-> %s\n", domain,
				       inet_ntoa(*((struct in_addr *) hp->h_addr)));
				memset(domain, '\0', 256);
			}
		}
	}
	free(f);
	free(my_string);
	free(c);
	free(s);
	free(e);
	puts("_EOF_");
	return 0;
}
